##
##  pound.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         pound
Summary:      HTTP/HTTPS Reverse Proxy
URL:          http://www.apsis.ch/pound/
Vendor:       APSIS
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Web
License:      GPL
Version:      2.8
Release:      20180511

#   package options
%option       with_fsl  yes

#   list of sources
Source0:      http://www.apsis.ch/pound/Pound-%{version}.tgz
Source1:      pound.cfg
Source2:      pound.pem
Source3:      rc.pound
Source4:      fsl.pound
Patch0:       pound.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101
BuildPreReq:  pcre, openssl-threads
PreReq:       pcre, openssl-threads
BuildPreReq:  pth, pth::with_pthread = yes
PreReq:       pth, pth::with_pthread = yes
%if "%{with_fsl}" == "yes"
BuildPreReq:  fsl
PreReq:       fsl
%endif

%description
    The Pound program is a reverse proxy, load balancer and HTTPS
    front-end for Web server(s). Pound was developed to enable
    distributing the load among several Web-servers and to allow for a
    convenient SSL wrapper for those Web servers that do not offer it
    natively.

%track
    prog pound = {
        version   = %{version}
        url       = http://www.apsis.ch/pound/
        regex     = Pound-(\d+(\.\d+)+)\.tgz
    }

%prep
    %setup -q -n Pound-%{version}
    %patch -p0

    #   force to use PCRE instead of vendor regex(3)
    %{l_shtool} subst \
        -e 's;regex\.h;pcreposix.h;' \
        -e 's;HAVE_REGEX_H;HAVE_PCREPOSIX_H;' \
        configure
    %{l_shtool} subst \
        -e 's;HAVE_REGEX_H;HAVE_PCREPOSIX_H;' \
        config.h.in
    %{l_shtool} subst \
        -e 's;HAVE_REGEX_H;HAVE_PCREPOSIX_H;' \
        -e 's;<regex\.h>;<pcreposix.h>;' \
        pound.h

    #   adjust hard-coded paths
    %{l_shtool} subst \
        -e 's;/usr/local/etc/pound/pound.cfg;%{l_prefix}/etc/pound/pound.cfg;' \
        -e 's;/var/run/pound.pid;%{l_prefix}/var/pound/pound.pid;' \
        Makefile.in pound.8 pound.c pound.h

%build
    #   configure package
    CC="%{l_cc}" \
    CFLAGS="%{l_cflags -O} %{l_cppflags openssl-threads .} `%{l_prefix}/bin/pthread-config --all --cflags`" \
    LDFLAGS="%{l_ldflags openssl-threads .} `%{l_prefix}/bin/pthread-config --all --ldflags`" \
    LIBS="`%{l_prefix}/bin/pthread-config --all --libs` %{l_fsl_libs} -lpcreposix -lpcre" \
    ./configure \
        --prefix=%{l_prefix} \
        --sysconfdir=%{l_prefix}/etc/pound \
        --with-ssl=%{l_prefix}

    #   build package
    %{l_make} %{l_mflags -O}

%install

    #   create installation hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/sbin \
        $RPM_BUILD_ROOT%{l_prefix}/etc/pound \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d \
        $RPM_BUILD_ROOT%{l_prefix}/man/man8 \
        $RPM_BUILD_ROOT%{l_prefix}/var/pound

    #   install program and manual page
    %{l_shtool} install -c -s -m 755 \
        pound poundctl $RPM_BUILD_ROOT%{l_prefix}/sbin/
    %{l_shtool} install -c -m 644 \
        pound.8 poundctl.8 $RPM_BUILD_ROOT%{l_prefix}/man/man8/

    #   install default configuration
    %{l_shtool} install -c -m 644 %{l_value -s -a} \
        %{SOURCE pound.cfg} $RPM_BUILD_ROOT%{l_prefix}/etc/pound/
    %{l_shtool} install -c -m 644 \
        %{SOURCE pound.pem} $RPM_BUILD_ROOT%{l_prefix}/etc/pound/

    #   install run-command script
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE rc.pound} $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/

    #   install OSSP fsl configuration
    %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/etc/fsl
    %{l_shtool} install -c -m 644 %{l_value -s -a} \
        %{SOURCE fsl.pound} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/fsl/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%config %{l_prefix}/etc/fsl/fsl.pound' \
        '%config %{l_prefix}/etc/pound/*'

%files -f files

%clean

%post
    #   after upgrade, restart service
    [ $1 -eq 2 ] || exit 0
    eval `%{l_rc} pound status 2>/dev/null`
    [ ".$pound_active" = .yes ] && %{l_rc} pound restart
    exit 0

%preun
    #   before erase, stop service and remove log files
    [ $1 -eq 0 ] || exit 0
    %{l_rc} pound stop 2>/dev/null
    rm -f $RPM_INSTALL_PREFIX/var/pound/*.log* >/dev/null 2>&1 || true
    exit 0

